# Backscatter.io Ruby

BackscatterIO - the Ruby gem for the Backscatter.io

[This is the Backscatter.io API.](https://backscatter.io/developers) 

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build backscatterio.gemspec
```

Then either install the gem locally:

```shell
gem install ./backscatterio-1.0.0.gem
```
(for development, run `gem install --dev ./backscatterio-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'backscatterio', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/backscatterio/ruby, then add the following in the Gemfile:

    gem 'backscatterio', :git => 'https://github.com/backscatterio/ruby.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'backscatterio'

# Setup authorization
BackscatterIO.configure do |config|
  # Configure API key authorization: ApiKeyAuth
  config.api_key['X-API-KEY'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-API-KEY'] = 'Bearer'
end

api_instance = BackscatterIO::Api.new

query = 'query_example' # String | 


begin
  #enriches asn
  result = api_instance.enrich_asn(query)
  p result
rescue BackscatterIO::ApiError => e
  puts "Exception when calling Api->enrich_asn: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://api.backscatter.io/v0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BackscatterIO::Api* | [**enrich_asn**](docs/Api.md#enrich_asn) | **GET** /enrichment/asn | enriches asn
*BackscatterIO::Api* | [**enrich_ip**](docs/Api.md#enrich_ip) | **GET** /enrichment/ip | enriches ip
*BackscatterIO::Api* | [**enrich_network**](docs/Api.md#enrich_network) | **GET** /enrichment/network | enriches network
*BackscatterIO::Api* | [**hello**](docs/Api.md#hello) | **GET** /hello | authenticate to the service
*BackscatterIO::Api* | [**observations**](docs/Api.md#observations) | **GET** /observations/{queryType} | fetches observations for a given ip address
*BackscatterIO::Api* | [**trends**](docs/Api.md#trends) | **GET** /trends/popular/{trendType} | Top N items


## Documentation for Models

 - [BackscatterIO::ASNEnrichment](docs/ASNEnrichment.md)
 - [BackscatterIO::ASNEnrichmentResults](docs/ASNEnrichmentResults.md)
 - [BackscatterIO::Hello](docs/Hello.md)
 - [BackscatterIO::IPEnrichment](docs/IPEnrichment.md)
 - [BackscatterIO::IPEnrichmentResults](docs/IPEnrichmentResults.md)
 - [BackscatterIO::NetworkEnrichment](docs/NetworkEnrichment.md)
 - [BackscatterIO::NetworkEnrichmentResults](docs/NetworkEnrichmentResults.md)
 - [BackscatterIO::Observation](docs/Observation.md)
 - [BackscatterIO::Observations](docs/Observations.md)
 - [BackscatterIO::Query](docs/Query.md)
 - [BackscatterIO::Results](docs/Results.md)
 - [BackscatterIO::Summary](docs/Summary.md)
 - [BackscatterIO::Trends](docs/Trends.md)
 - [BackscatterIO::Unique](docs/Unique.md)


## Documentation for Authorization


### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-KEY
- **Location**: HTTP header

